2023-02-15 12:16:31 +00:00
#!/usr/bin/env bash
2024-01-27 08:39:37 +00:00
VERSION = "v0.3.8"
### ChangeNotes: Fixed --env-file logic to work with multiple env-files.
2023-02-02 21:02:41 +00:00
Github = "https://github.com/mag37/dockcheck"
2023-03-05 20:25:22 +00:00
RawUrl = "https://raw.githubusercontent.com/mag37/dockcheck/main/dockcheck.sh"
2023-02-02 21:02:41 +00:00
2023-03-04 18:56:26 +00:00
### Variables for self updating
ScriptArgs = ( " $@ " )
ScriptPath = " $( readlink -f " $0 " ) "
ScriptName = " $( basename " $ScriptPath " ) "
ScriptWorkDir = " $( dirname " $ScriptPath " ) "
2023-01-18 10:50:00 +00:00
2023-03-05 19:44:05 +00:00
### Check if there's a new release of the script:
LatestRelease = " $( curl -s -r 0-50 $RawUrl | sed -n "/VERSION/s/VERSION=//p" | tr -d '"' ) "
LatestChanges = " $( curl -s -r 0-200 $RawUrl | sed -n "/ChangeNotes/s/### ChangeNotes: //p" ) "
2024-01-01 18:46:09 +00:00
2023-01-30 19:39:27 +00:00
### Help Function:
2023-01-19 11:09:29 +00:00
Help( ) {
2023-02-09 12:03:27 +00:00
echo "Syntax: dockcheck.sh [OPTION] [part of name to filter]"
2023-12-13 18:50:58 +00:00
echo "Example: dockcheck.sh -y -d 10 -e nextcloud,heimdall"
2023-02-09 12:03:27 +00:00
echo
echo "Options:"
echo "-a|y Automatic updates, without interaction."
2023-12-14 08:06:19 +00:00
echo "-d N Only update to new images that are N+ days old. Lists too recent with +prefix and age. 2xSlower."
2023-12-23 19:47:23 +00:00
echo "-e X Exclude containers, separated by comma."
2024-01-21 19:29:29 +00:00
echo "-f Force stack restart after update. Caution: restarts once for every updated container within stack."
2023-12-23 19:47:23 +00:00
echo "-h Print this Help."
2024-01-05 23:11:33 +00:00
echo "-i Inform - send a preconfigured notification."
2024-01-18 19:59:55 +00:00
echo "-l Only update if label is set. See readme."
2023-12-23 19:47:23 +00:00
echo "-m Monochrome mode, no printf color codes."
echo "-n No updates, only checking availability."
2023-02-15 12:16:31 +00:00
echo "-p Auto-Prune dangling images after update."
2023-08-28 19:24:23 +00:00
echo "-r Allow updating images for docker run, wont update the container"
echo "-s Include stopped containers in the check. (Logic: docker ps -a)"
2023-02-09 12:03:27 +00:00
}
2023-01-19 11:09:29 +00:00
2023-12-19 19:24:34 +00:00
### Colors:
c_red = "\033[0;31m"
c_green = "\033[0;32m"
c_yellow = "\033[0;33m"
c_blue = "\033[0;34m"
c_teal = "\033[0;36m"
c_reset = "\033[0m"
2023-08-28 19:24:23 +00:00
Stopped = ""
2024-01-18 19:59:55 +00:00
while getopts "aynpfrhlisme:d:" options; do
2023-02-09 12:03:27 +00:00
case " ${ options } " in
2023-12-23 19:47:23 +00:00
a| y) AutoUp = "yes" ; ;
n) AutoUp = "no" ; ;
r) DRunUp = "yes" ; ;
p) AutoPrune = "yes" ; ;
2024-01-18 19:59:55 +00:00
l) OnlyLabel = true ; ;
f) ForceRestartStacks = true ; ;
2024-01-05 23:11:33 +00:00
i) [ -s $ScriptWorkDir /notify.sh ] && { source $ScriptWorkDir /notify.sh ; Notify = "yes" ; } ; ;
2023-12-13 18:50:58 +00:00
e) Exclude = ${ OPTARG } ; ;
2023-12-19 21:52:11 +00:00
m) declare c_{ red,green,yellow,blue,teal,reset} = "" ; ;
2023-12-13 18:50:58 +00:00
s) Stopped = "-a" ; ;
d) DaysOld = ${ OPTARG }
if ! [ [ $DaysOld = ~ ^[ 0-9] +$ ] ] ; then { printf "Days -d argument given (%s) is not a number.\n" " ${ DaysOld } " ; exit 2 ; } ; fi ; ;
h| *) Help ; exit 2 ; ;
2023-02-09 12:03:27 +00:00
esac
done
shift " $(( OPTIND-1)) "
2023-01-19 11:09:29 +00:00
2023-03-04 18:56:26 +00:00
self_update_git( ) {
cd " $ScriptWorkDir " || { printf "Path error, skipping update.\n" ; return ; }
[ [ $( builtin type -P git) ] ] || { printf "Git not installed, skipping update.\n" ; return ; }
2023-03-05 20:59:08 +00:00
ScriptUpstream = $( git rev-parse --abbrev-ref --symbolic-full-name "@{upstream}" ) || { printf "Script not in git directory, choose a different method.\n" ; self_update_select ; return ; }
2023-03-04 18:56:26 +00:00
git fetch
2023-03-04 19:21:31 +00:00
[ -n " $( git diff --name-only " $ScriptUpstream " " $ScriptName " ) " ] && {
2023-03-04 18:56:26 +00:00
printf "%s\n" "Pulling the latest version."
git pull --force
2023-03-05 12:50:28 +00:00
printf "%s\n" "--- starting over with the updated version ---"
2023-03-04 18:56:26 +00:00
cd - || { printf "Path error.\n" ; return ; }
exec " $ScriptPath " " ${ ScriptArgs [@] } " # run the new script with old arguments
exit 1 # exit the old instance
}
echo "Local is already latest."
}
self_update_curl( ) {
cp " $ScriptPath " " $ScriptPath " .bak
if [ [ $( builtin type -P curl) ] ] ; then
curl -L $RawUrl > " $ScriptPath " ; chmod +x " $ScriptPath "
printf "%s\n" "--- starting over with the updated version ---"
exec " $ScriptPath " " ${ ScriptArgs [@] } " # run the new script with old arguments
exit 1 # exit the old instance
else
printf "curl not available - download the update manually: %s \n" " $RawUrl "
fi
}
2023-03-05 13:08:56 +00:00
self_update_select( ) {
2023-03-04 18:56:26 +00:00
read -r -p "Choose update procedure (or do it manually) - git/curl/[no]: " SelfUpQ
if [ [ " $SelfUpQ " = = "git" ] ] ; then self_update_git ;
elif [ [ " $SelfUpQ " = = "curl" ] ] ; then self_update_curl ;
else printf "Download it manually from the repo: %s \n\n" " $Github "
fi
2023-03-05 13:08:56 +00:00
}
### Choose from list -function:
choosecontainers( ) {
while [ [ -z " $ChoiceClean " ] ] ; do
read -r -p "Enter number(s) separated by comma, [a] for all - [q] to quit: " Choice
if [ [ " $Choice " = ~ [ qQnN] ] ] ; then
exit 0
elif [ [ " $Choice " = ~ [ aAyY] ] ] ; then
SelectedUpdates = ( " ${ GotUpdates [@] } " )
ChoiceClean = ${ Choice //[,. : ;]/ }
else
ChoiceClean = ${ Choice //[,. : ;]/ }
for CC in $ChoiceClean ; do
if [ [ " $CC " -lt 1 || " $CC " -gt $UpdCount ] ] ; then # reset choice if out of bounds
echo " Number not in list: $CC " ; unset ChoiceClean ; break 1
else
SelectedUpdates += ( " ${ GotUpdates [ $CC -1] } " )
fi
done
fi
done
printf "\nUpdating containers:\n"
printf "%s\n" " ${ SelectedUpdates [@] } "
printf "\n"
}
2023-12-13 18:50:58 +00:00
datecheck( ) {
ImageDate = $( $regbin image inspect " $RepoUrl " --format= '{{.Created}}' | cut -d" " -f1 )
2023-12-14 08:06:19 +00:00
ImageAge = $(( ( $( date +%s) - $( date -d " $ImageDate " +%s) ) / 86400 ))
if [ $ImageAge -gt $DaysOld ] ; then
2023-12-13 18:50:58 +00:00
return 0
else
return 1
fi
}
2024-01-17 19:26:18 +00:00
progress_bar( ) {
QueCurrent = " $1 "
QueTotal = " $2 "
( ( Percent = 100*${ QueCurrent } /${ QueTotal } ) )
( ( Complete = 50*${ Percent } /100) ) # change first number for width (50)
( ( Left = 50-${ Complete } ) ) # change first number for width (50)
BarComplete = $( printf " % ${ Complete } s " | tr " " "#" )
BarLeft = $( printf " % ${ Left } s " | tr " " "-" )
[ [ $QueTotal = = $QueCurrent ] ] || printf "\r[%s%s] %s/%s " $BarComplete $BarLeft $QueCurrent $QueTotal
[ [ $QueTotal = = $QueCurrent ] ] && printf "\r[%b%s%b] %s/%s \n" $c_teal $BarComplete $c_reset $QueCurrent $QueTotal
}
2023-12-13 18:50:58 +00:00
2023-03-05 13:08:56 +00:00
### Version check & initiate self update
2024-01-24 20:28:53 +00:00
[ [ " $VERSION " != " $LatestRelease " ] ] && { printf "New version available! %b%s%b ⇒ %b%s%b \n Change Notes: %s \n" " $c_yellow " " $VERSION " " $c_reset " " $c_green " " $LatestRelease " " $c_reset " " $LatestChanges " ; [ [ -z " $AutoUp " ] ] && self_update_select ; }
2023-03-04 18:56:26 +00:00
2023-02-09 12:03:27 +00:00
### Set $1 to a variable for name filtering later.
SearchName = " $1 "
2023-02-26 06:49:57 +00:00
### Create array of excludes
IFS = ',' read -r -a Excludes <<< " $Exclude " ; unset IFS
2023-01-19 11:09:29 +00:00
2023-02-09 12:03:27 +00:00
### Check if required binary exists in PATH or directory:
2023-02-15 12:16:31 +00:00
if [ [ $( builtin type -P "regctl" ) ] ] ; then regbin = "regctl" ;
2023-11-19 19:20:05 +00:00
elif [ [ -f " $ScriptWorkDir /regctl " ] ] ; then regbin = " $ScriptWorkDir /regctl " ;
2023-02-09 12:03:27 +00:00
else
2023-02-15 12:16:31 +00:00
read -r -p "Required dependency 'regctl' missing, do you want it downloaded? y/[n] " GetDep
if [ [ " $GetDep " = ~ [ yY] ] ] ; then
2023-02-09 12:03:27 +00:00
### Check arch:
case " $( uname --machine) " in
x86_64| amd64) architecture = "amd64" ; ;
arm64| aarch64) architecture = "arm64" ; ;
2023-02-15 12:16:31 +00:00
*) echo "Architecture not supported, exiting." ; exit 1; ;
2023-02-09 12:03:27 +00:00
esac
2023-02-15 12:16:31 +00:00
RegUrl = " https://github.com/regclient/regclient/releases/latest/download/regctl-linux- $architecture "
2023-12-09 09:56:22 +00:00
if [ [ $( builtin type -P curl) ] ] ; then curl -L $RegUrl > " $ScriptWorkDir /regctl " ; chmod +x " $ScriptWorkDir /regctl " ; regbin = " $ScriptWorkDir /regctl " ;
elif [ [ $( builtin type -P wget) ] ] ; then wget $RegUrl -O " $ScriptWorkDir /regctl " ; chmod +x " $ScriptWorkDir /regctl " ; regbin = " $ScriptWorkDir /regctl " ;
2023-02-15 12:16:31 +00:00
else
printf "%s\n" "curl/wget not available - get regctl manually from the repo link, quitting."
fi
2023-02-09 12:03:27 +00:00
else
printf "%s\n" "Dependency missing, quitting."
2023-02-15 12:16:31 +00:00
exit 1
2023-02-09 12:03:27 +00:00
fi
fi
2023-02-15 12:16:31 +00:00
### final check if binary is correct
$regbin version & > /dev/null || { printf "%s\n" "regctl is not working - try to remove it and re-download it, exiting." ; exit 1; }
2023-02-09 12:03:27 +00:00
### Check docker compose binary:
2023-03-05 13:18:57 +00:00
if docker compose version & > /dev/null ; then DockerBin = "docker compose" ;
elif docker-compose -v & > /dev/null; then DockerBin = "docker-compose" ;
2023-02-10 20:06:12 +00:00
elif docker -v & > /dev/null; then
printf "%s\n" "No docker compose binary available, using plain docker (Not recommended!)"
printf "%s\n" "'docker run' will ONLY update images, not the container itself."
2023-02-09 12:03:27 +00:00
else
2023-02-10 20:06:12 +00:00
printf "%s\n" "No docker binaries available, exiting."
2023-02-15 12:16:31 +00:00
exit 1
2023-02-09 12:03:27 +00:00
fi
2023-01-30 09:08:13 +00:00
2023-02-09 12:03:27 +00:00
### Numbered List -function:
options( ) {
2023-02-15 12:16:31 +00:00
num = 1
for i in " ${ GotUpdates [@] } " ; do
2023-02-09 12:03:27 +00:00
echo " $num ) $i "
( ( num++) )
done
}
2023-01-30 09:08:13 +00:00
2023-06-21 18:09:31 +00:00
### Listing typed exclusions:
if [ [ -n ${ Excludes [*] } ] ] ; then
2023-12-19 19:24:34 +00:00
printf "\n%bExcluding these names:%b\n" $c_blue $c_reset
2023-06-21 18:09:31 +00:00
printf "%s\n" " ${ Excludes [@] } "
printf "\n"
fi
2024-01-17 19:26:18 +00:00
# Variables for progress_bar function
DocCount = $( docker ps --filter " name= $SearchName " --format '{{.Names}}' | wc -l)
RegCheckQue = 0
2023-02-09 12:03:27 +00:00
### Check the image-hash of every running container VS the registry
2023-08-28 19:24:23 +00:00
for i in $( docker ps $Stopped --filter " name= $SearchName " --format '{{.Names}}' ) ; do
2024-01-17 19:26:18 +00:00
( ( RegCheckQue += 1) )
progress_bar $RegCheckQue $DocCount
2023-08-28 19:24:23 +00:00
### Looping every item over the list of excluded names and skipping:
2023-06-21 18:09:31 +00:00
for e in " ${ Excludes [@] } " ; do [ [ " $i " = = " $e " ] ] && continue 2 ; done
2023-02-09 12:03:27 +00:00
RepoUrl = $( docker inspect " $i " --format= '{{.Config.Image}}' )
LocalHash = $( docker image inspect " $RepoUrl " --format '{{.RepoDigests}}' )
2023-02-12 18:40:42 +00:00
### Checking for errors while setting the variable:
2024-01-15 19:27:45 +00:00
if RegHash = $( $regbin image digest --list " $RepoUrl " 2>& 1) ; then
2023-12-13 18:50:58 +00:00
if [ [ " $LocalHash " = *" $RegHash " * ] ] ; then
NoUpdates += ( " $i " )
else
if [ [ -n " $DaysOld " ] ] && ! datecheck ; then
2023-12-14 08:06:19 +00:00
NoUpdates += ( " + $i ${ ImageAge } d " )
2023-12-13 18:50:58 +00:00
else
GotUpdates += ( " $i " )
fi
fi
2023-02-09 12:03:27 +00:00
else
2024-01-15 19:27:45 +00:00
# Here the RegHash is the result of an error code.
GotErrors += ( " $i - ${ RegHash } " )
2023-02-09 12:03:27 +00:00
fi
done
2023-01-18 10:50:00 +00:00
2023-02-09 12:03:27 +00:00
### Sort arrays alphabetically
IFS = $'\n'
NoUpdates = ( $( sort <<< " ${ NoUpdates [*] } " ) )
2023-02-01 18:39:43 +00:00
GotUpdates = ( $( sort <<< " ${ GotUpdates [*] } " ) )
GotErrors = ( $( sort <<< " ${ GotErrors [*] } " ) )
unset IFS
2023-02-15 12:16:31 +00:00
### Define how many updates are available
UpdCount = " ${# GotUpdates [@] } "
2023-01-30 09:08:13 +00:00
2023-01-18 10:50:00 +00:00
### List what containers got updates or not
2023-02-12 18:40:42 +00:00
if [ [ -n ${ NoUpdates [*] } ] ] ; then
2023-12-19 19:24:34 +00:00
printf "\n%bContainers on latest version:%b\n" " $c_green " " $c_reset "
2023-01-18 10:50:00 +00:00
printf "%s\n" " ${ NoUpdates [@] } "
fi
2023-02-12 18:40:42 +00:00
if [ [ -n ${ GotErrors [*] } ] ] ; then
2023-12-19 19:24:34 +00:00
printf "\n%bContainers with errors, wont get updated:%b\n" " $c_red " " $c_reset "
2023-01-20 11:47:17 +00:00
printf "%s\n" " ${ GotErrors [@] } "
2024-01-15 19:27:45 +00:00
printf "%binfo:%b 'unauthorized' often means not found in a public registry.%b\n" " $c_blue " " $c_reset "
2023-01-20 11:47:17 +00:00
fi
2023-02-12 18:40:42 +00:00
if [ [ -n ${ GotUpdates [*] } ] ] ; then
2023-12-19 19:24:34 +00:00
printf "\n%bContainers with updates available:%b\n" " $c_yellow " " $c_reset "
2023-12-23 19:47:23 +00:00
[ [ -z " $AutoUp " ] ] && options || printf "%s\n" " ${ GotUpdates [@] } "
2024-01-05 23:11:33 +00:00
[ [ ! -z " $Notify " ] ] && { [ [ $( type -t send_notification) = = function ] ] && send_notification " ${ GotUpdates [@] } " || printf "Could not source notification function.\n" ; }
2023-01-30 09:08:13 +00:00
fi
2023-01-18 10:50:00 +00:00
2023-01-18 20:45:31 +00:00
### Optionally get updates if there's any
if [ -n " $GotUpdates " ] ; then
2023-12-23 19:47:23 +00:00
if [ -z " $AutoUp " ] ; then
2023-12-19 19:24:34 +00:00
printf "\n%bChoose what containers to update.%b\n" " $c_teal " " $c_reset "
2023-02-07 13:56:18 +00:00
choosecontainers
2023-01-30 09:08:13 +00:00
else
SelectedUpdates = ( " ${ GotUpdates [@] } " )
fi
2023-12-23 19:47:23 +00:00
if [ " $AutoUp " = = " ${ AutoUp #[Nn] } " ] ; then
2023-06-27 17:34:20 +00:00
NumberofUpdates = " ${# SelectedUpdates [@] } "
CurrentQue = 0
2023-01-30 09:08:13 +00:00
for i in " ${ SelectedUpdates [@] } "
2023-03-01 19:39:02 +00:00
do
2023-06-27 17:34:20 +00:00
( ( CurrentQue += 1) )
2023-03-01 19:39:02 +00:00
unset CompleteConfs
2023-02-09 10:33:02 +00:00
ContPath = $( docker inspect " $i " --format '{{ index .Config.Labels "com.docker.compose.project.working_dir" }}' )
ContConfigFile = $( docker inspect " $i " --format '{{ index .Config.Labels "com.docker.compose.project.config_files" }}' )
2023-02-04 11:35:08 +00:00
ContName = $( docker inspect " $i " --format '{{ index .Config.Labels "com.docker.compose.service" }}' )
2023-02-19 13:21:22 +00:00
ContEnv = $( docker inspect " $i " --format '{{index .Config.Labels "com.docker.compose.project.environment_file" }}' )
2023-02-23 12:05:06 +00:00
ContImage = $( docker inspect " $i " --format= '{{.Config.Image}}' )
2024-01-18 19:59:55 +00:00
ContUpdateLabel = $( docker inspect " $i " --format '{{ index .Config.Labels "mag37.dockcheck.update" }}' )
ContRestartStack = $( docker inspect " $i " --format '{{ index .Config.Labels "mag37.dockcheck.restart-stack" }}' )
2023-02-10 20:06:12 +00:00
### Checking if compose-values are empty - hence started with docker run:
if [ -z " $ContPath " ] ; then
2023-12-23 19:47:23 +00:00
if [ " $DRunUp " = = "yes" ] ; then
2023-02-12 18:40:42 +00:00
docker pull " $ContImage "
2023-02-10 20:06:12 +00:00
printf "%s\n" " $i got a new image downloaded, rebuild manually with preferred 'docker run'-parameters "
else
2023-12-19 19:24:34 +00:00
printf "\n%b%s%b has no compose labels, probably started with docker run - %bskipping%b\n\n" " $c_yellow " " $i " " $c_reset " " $c_yellow " " $c_reset "
2023-02-10 20:06:12 +00:00
fi
continue
fi
2023-02-09 12:00:29 +00:00
### Checking if "com.docker.compose.project.config_files" returns the full path to the config file or just the file name
if [ [ $ContConfigFile = '/' * ] ] ; then
ComposeFile = " $ContConfigFile "
else
ComposeFile = " $ContPath / $ContConfigFile "
fi
2023-02-12 18:40:42 +00:00
### cd to the compose-file directory to account for people who use relative volumes, eg - ${PWD}/data:data
2023-03-01 19:52:17 +00:00
cd " $ContPath " || { echo " Path error - skipping $i " ; continue ; }
2023-12-19 19:24:34 +00:00
printf "\n%bNow updating (%s/%s): %b%s%b\n" " $c_teal " " $CurrentQue " " $NumberofUpdates " " $c_blue " " $i " " $c_reset "
2024-01-18 19:59:55 +00:00
### Checking if Label Only -option is set, and if container got the label
2024-01-26 19:45:02 +00:00
[ [ " $OnlyLabel " = = true ] ] && { [ [ " $ContUpdateLabel " != true ] ] && { echo "No update label, skipping." ; continue ; } }
2023-02-23 12:05:06 +00:00
docker pull " $ContImage "
2023-02-25 09:32:22 +00:00
### Reformat for multi-compose:
2023-03-04 18:56:26 +00:00
IFS = ',' read -r -a Confs <<< " $ComposeFile " ; unset IFS
2023-02-25 09:32:22 +00:00
for conf in " ${ Confs [@] } " ; do CompleteConfs += " -f $conf " ; done
2023-02-19 13:21:22 +00:00
### Check if the container got an environment file set, use it if so:
2024-01-26 19:45:02 +00:00
if [ -n " $ContEnv " ] ; then
### prepare env-files arguments
ContEnvs = $( for env in ${ ContEnv //,/ } ; do printf -- "--env-file %s " $env ; done )
### Check if the whole stack should be restarted
2024-01-18 19:59:55 +00:00
if [ [ " $ContRestartStack " = = true ] ] || [ [ " $ForceRestartStacks " = = true ] ] ; then
2024-01-26 19:45:02 +00:00
$DockerBin ${ CompleteConfs [@] } stop ; $DockerBin ${ CompleteConfs [@] } ${ ContEnvs } up -d
2024-01-18 19:59:55 +00:00
else
2024-01-26 19:45:02 +00:00
$DockerBin ${ CompleteConfs [@] } ${ ContEnvs } up -d " $ContName " # unquoted array to allow split - rework?
2024-01-18 19:59:55 +00:00
fi
2023-02-19 13:21:22 +00:00
else
2024-01-18 19:59:55 +00:00
if [ [ " $ContRestartStack " = = true ] ] || [ [ " $ForceRestartStacks " = = true ] ] ; then
$DockerBin ${ CompleteConfs [@] } stop ; $DockerBin ${ CompleteConfs [@] } up -d
else
$DockerBin ${ CompleteConfs [@] } up -d " $ContName "
fi
2023-02-19 13:21:22 +00:00
fi
2023-01-30 09:08:13 +00:00
done
2023-12-19 19:24:34 +00:00
printf "\n%bAll done!%b\n" " $c_green " " $c_reset "
2023-12-23 19:47:23 +00:00
[ [ -z " $AutoPrune " ] ] && read -r -p "Would you like to prune dangling images? y/[n]: " AutoPrune
[ [ " $AutoPrune " = ~ [ yY] ] ] && docker image prune -f
2023-01-30 09:08:13 +00:00
else
printf "\nNo updates installed, exiting.\n"
2023-01-20 10:52:47 +00:00
fi
2023-01-18 10:50:00 +00:00
else
2023-01-18 20:45:31 +00:00
printf "\nNo updates available, exiting.\n"
2023-01-18 10:50:00 +00:00
fi
2023-01-30 09:08:13 +00:00
exit 0
2024-01-17 19:26:18 +00:00